﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="MindFusion.Scheduling.WebForms" Namespace="MindFusion.Scheduling.WebForms"
	TagPrefix="MindFusion" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<title>Tutorial 5 - Styling the Calendar</title>
	<style type="text/css">
	    .blue .wrapper, .blue .frame
	    {
	        background: none #003366 !important;
	    }
	    
	    .red .wrapper, .red .frame
	    {
	        background: none #990066 !important;	
	    }
	</style>
</head>
<body>
	<form id="form1" runat="server">
	<asp:ScriptManager ID="ScriptManager1" runat="server">
	</asp:ScriptManager>
	<div>
		<asp:ListBox ID="lbContacts" runat="server" SelectionMode="Multiple" 
            Width="397px"></asp:ListBox><br />
        <asp:Button ID="Button1" runat="server" onclick="Button1_Click" 
            Text="Apply filter" />
        <asp:Button ID="Button2" runat="server" onclick="Button2_Click" 
            Text="Apply grouping" />
        <asp:Button ID="Button3" runat="server" onclick="Button3_Click" 
            Text="Clear grouping/filtering" />
		<MindFusion:Calendar ID="Calendar1" runat="server" Theme="Standard" CurrentView="Timetable"
			Height="400px" Width="400px" ItemCreatingScript="onItemCreating" ItemDeletingScript="onItemDeleting"
			ItemDragEndScript="onItemDragEnd"
			TimetableColumnHeaderClickScript="onHeaderClick"
			>
        <TimetableSettings StartTime="420" EndTime="1260"></TimetableSettings>
		</MindFusion:Calendar>
		<MindFusion:Calendar ID="Calendar2" runat="server" Theme="Standard" CurrentView="SingleMonth"
			Height="400px" Width="400px" Style="position: relative; top: -400px; left: 450px;"
			UseForms="false" SelectionEndScript="onSelectionEnd">
			<ItemSettings ShowMoreItemsCue="Disabled" ItemsVisible="Enabled" />
			<MonthSettings DayNamesHeader="Disabled" />
		</MindFusion:Calendar>
	</div>

	<script type="text/javascript">
	    function onSelectionEnd(sender, args) {
	        __doPostBack('__Page');
	    }

	    function onReminder(sender, args) {
	        alert(args.get_item().getReminder().getMessage());
	    }

	    function onItemDragEnd(sender, args) {
	        //get the list of contacts associated with the item
	        var contacts = args.get_item().getContacts();
	        if (contacts.length > 0) {
	            //get the first contact
	            var contact = contacts[0];
	            //get all items associated with this contact id
	            var items = sender.getItemsByResourceId(contact.getId());
	            // get the start and end time of the dragged item
	            var d1 = args.get_changes().startTime.valueOf();
	            var d2 = args.get_changes().endTime.valueOf();
	            //check if another, associated with this contact, item is present within the same time range
	            for (var i = 0, l = items.length; i < l; i++) {
	                var item = items[i];
	                var id1 = item.getStartTime().valueOf();
	                var id2 = item.getEndTime().valueOf();
	                //if another item is present display a warning and cancel the modification of the item
	                if ((d1 < id2) && (d2 > id1) && (Array.indexOf(item.getContacts(), contact) > -1) && !itemsEqual(item,args.get_item())) {
	                    alert('{0} {1} is busy at this time'.format(contact.getFirstName(), contact.getLastName()));
	                    args.set_cancel(true);
	                    return;
	                }
	            }
	        }
	    }

	    function onItemCreating(sender, args) {
	        //get the list of contacts id-s associated with the item 
	        var contacts = args.get_item().contacts;
	        if (contacts && contacts.length > 0) {
	            //get the first contact
	            var contact = sender.getResourceById(contacts[0]);
	            //get all items
	            var items = sender.getItems();
	            //get the start and end time of the item to be created
	            var d1 = args.get_item().startTime.valueOf();
	            var d2 = args.get_item().endTime.valueOf();
	            //check if another, associated with this contact, item is present within the same time range 
	            for (var i = 0, l = items.length; i < l; i++) {
	                var item = items[i];

	                var id1 = item.getStartTime().valueOf();
	                var id2 = item.getEndTime().valueOf();
	                //if another item is present display a warning and cancel the creation of the item
	                if ((d1 < id2) && (d2 > id1) && Array.indexOf(item.getContacts(), contact) > -1) {
	                    alert('{0} {1} is busy at this time'.format(contact.getFirstName(), contact.getLastName()));
	                    args.set_cancel(true);
	                    return;
	                }
	            }
	        }
	    }

	    function onItemDeleting(sender, args) {
	        //check the subject of the item to be deleted
	        //display a warning and cancel the event
	        if (args.get_item().getSubject() == 'Meeting') {
	            alert('This appointment cannot be deleted!')
	            args.set_cancel(true);
	        }
	    }

	    function itemsEqual(item1, item2) {
	        if (item1.id == item2.id && item1.occurrenceIndex == item2.occurrenceIndex)
	            return true;
	        return false;
	    }
	    
	    function onHeaderClick(sender, args) {
	        //get the resources by which the calendar is filtered
	        var resources = sender.getFilteredResources();
	        if (resources.length > 0) {
	            var contact = resources[0];
	            //get the list of all items defined in the calendar
	            var items = sender.getItems();
	            var cnt = 0;
	            for (var i = 0, l = items.length; i < l; i++) {
	                var item = items[i];
	                var date1 = item.getStartTime().getDate();
	                var date2 = item.getEndTime().getDate();
	                var date = args.get_date().getDate();
	                //check if the item is associated with the resource
	                if (Array.indexOf(item.getContacts(), contact) > -1) {
	                    //increase the counter if the item is within the specified time range
	                    if ((date1 == date) || (date2 == date) || (date1 <= date && date2 >= date)) {
	                        cnt += 1;
	                    }
	                }
	            }
	            //display the count of appointments associated with the resource
	            alert('{0} has {1} appointment(s) on {2}'.format(contact.getFirstName(), cnt, args.get_date().toString('dd MMMM')));
	        }
	    }

	</script>
	</form>
</body>
</html>